﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Custom View classa
#Event: FileSelected(Property As String, Value As String)
#Event: ItemDeleted(Value As String, m as map)
#Event: ItemUpdated(Value As String, m as String)
#Event: ItemSelected(json As String, m as map)
#Event: ItemCloned(Value As String)
#Event: ItemCopied(Value As String)
#Event: ItemExported(Value As String)
#Event: ItemNew()
#Event: LoadFields()
'#Event: CheckBoxChanged(Property As String, Value As Boolean)
#Event: ComboChanged(Property As String, Value As Object)
#Event: Clicked(Property As String, Value as map)
'#Event: ColorChanged(Property As String, Value As Object)
#Event: IconPicker(Property As string, Value As String)
'#Event: ComboButton(Property As String)
#Event: MakeActive(Value As String)
#Event: MakeInActive(Value As String)
#Event: Query(Property As String, Value As String)
#Event: Sorted(Value As String)
'#Event: TextAreaChanged(Property As String, TagOldNewMap As Map)
'#Event: TextFieldChanged(Property As String, TagOldNewMap As Map)
'#Event: DatePickerValueChanged(Property As String, Value As Long)
'#Event: SpinnerValueChanged(Property As String, Value As Object)
'#Event: SliderValueChange(Property As String, Value As Double)
'#Event: ToggleButton(Property As String, Value As Boolean)
'#Event: RadioButton(Property As String, Value As Text)
'#Event: Switch(Property As String, Value As Boolean)
#Event: Update(RowIndex As Int, Value As Map)
#Event: Delete(RowIndex As Int, Value As Map)
#Event: ItemError(Value As String)
#Event: FieldSelect(Property as string,Value As String)

#RaisesSynchronousEvents: FieldSelect
#RaisesSynchronousEvents: ItemError
#RaisesSynchronousEvents: Update
#RaisesSynchronousEvents: Delete
'#RaisesSynchronousEvents: Switch
'#RaisesSynchronousEvents: RadioButton
'#RaisesSynchronousEvents: ToggleButton
'#RaisesSynchronousEvents: TextAreaChanged
'#RaisesSynchronousEvents: TextFieldChanged
'#RaisesSynchronousEvents: DatePickerValueChanged
'#RaisesSynchronousEvents: SpinnerValueChanged
'#RaisesSynchronousEvents: SliderValueChange
#RaisesSynchronousEvents: FileSelected
#RaisesSynchronousEvents: ItemDeleted
#RaisesSynchronousEvents: ItemUpdated
#RaisesSynchronousEvents: ItemSelected
#RaisesSynchronousEvents: ItemCloned
#RaisesSynchronousEvents: ItemCopied
#RaisesSynchronousEvents: ItemExported
#RaisesSynchronousEvents: ItemNew
#RaisesSynchronousEvents: LoadFields
'#RaisesSynchronousEvents: CheckBoxChanged
'#RaisesSynchronousEvents: ComboChanged
#RaisesSynchronousEvents: Clicked
'#RaisesSynchronousEvents: ColorChanged
#RaisesSynchronousEvents: IconPicker
'#RaisesSynchronousEvents: ComboButton
#RaisesSynchronousEvents: MakeActive
#RaisesSynchronousEvents: MakeInActive
#RaisesSynchronousEvents: Query
#RaisesSynchronousEvents: Sorted

#DesignerProperty: Key: CRUDOnly, DisplayName: CRUD Only, FieldType: Boolean, DefaultValue: False, Description: Show crud only buttons

'add condition map
Sub AddConditions(Property2Test As String, TestValue As String, conMap As Map, OverWrite As Boolean, GetFromAnotherProperty As Boolean)
	If EditTV.IsInitialized = True Then EditTV.AddConditions(Property2Test, TestValue, conMap, OverWrite, GetFromAnotherProperty)
End Sub

Sub Conditions() As List
	Return EditTV.conditions
End Sub

Sub LoadCSS
	If EditTV.IsInitialized Then EditTV.LoadCSS
End Sub


Sub Remove
	If EditTV.IsInitialized Then EditTV.TV.RemoveNodeFromParent
End Sub

Sub Class_Globals
	Private fx As JFX
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As Pane
	Public ShowDelete As Boolean
	Public ShowUpdate As Boolean
	Private btnAdd As Button
	Private CRUDOnly As Boolean
	Private btnDelete As Button
	Private btnUpdate As Button
	Private lvKeys As ListView
	Private vSplit As SplitPane
	Public EditTV As EditableTV
	Public PrimaryKey As String
	Public PrimaryValue As String
	Private ParentForm As Form
	Public ShouldSort As Boolean = True
	Private btnClone As Button
	Private btnCopyFromClipboard As Button
	Private btnToClipboard As Button
	Private btnExport As Button
	Private btnImport As Button
	Private btnLoadFields As Button
	Private btnPrint As Button
	Private minSize As Int = 250
	Private maxSize As Int = 300
	Public GetLastDeleted As Map
	Private kvs As clsKVS
	Private btnMakeActive As Button
	Private btnMakeInactive As Button
	Public SecondaryKey As String
	Private hTxt1 As String
	Public GetLastUpdated As Map
	Private btnSortRC As Button
	Public ReadOnly As List
	Private SavePather As String
	Private SavePath As String
End Sub

Sub ContainsProperty(sPropertyName As String) As Boolean
	If EditTV.IsInitialized = False Then Return False
	Return EditTV.ContainsProperty(sPropertyName)
End Sub

Sub SetReadOnly(lst As List)
	If EditTV.IsInitialized Then EditTV.ReadOnly = lst
End Sub


Sub AddFieldSelectorProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String, yList As List, bSort As Boolean)
	If EditTV.IsInitialized Then EditTV.AddFieldSelectorProperty(propHeader, propValue, propDescription , propTag , yList, bSort)
End Sub

Sub AddSliderProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String,minValue As Double,maxValue As Double)
	If EditTV.IsInitialized Then EditTV.AddSliderProperty(propHeader, propValue, propDescription, propTag,minValue,maxValue)
End Sub


Sub AddSpinnerProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String,minValue As Double,maxValue As Double,stepValue As Double)
	If EditTV.IsInitialized Then EditTV.AddSpinnerProperty(propHeader, propValue, propDescription, propTag,minValue,maxValue,stepValue)
End Sub


Sub AddProgressBarProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddProgressBarProperty(propHeader, propValue, propDescription, propTag)
End Sub


'Add color picker property
Sub AddColorPickerProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddColorPickerProperty(propHeader,propValue,propDescription, propTag)
End Sub

Sub Refresh
	If EditTV.IsInitialized Then EditTV.refresh
End Sub

Sub Reset(bHide As Boolean)
	If EditTV.IsInitialized Then EditTV.SetPropertyViewer
End Sub

Sub SetLoading(bLoading As Boolean)
	If EditTV.IsInitialized Then EditTV.SetLoading(bLoading)
End Sub

Sub SetImagesFolder(imgFolder As String)
	If EditTV.IsInitialized Then EditTV.ImagesFolder = imgFolder
End Sub

Sub GetPropertyBag() As Map
	If EditTV.IsInitialized Then 
		Return EditTV.GetPropertyBag
	Else
		Dim m As Map
		m.Initialize
		Return m
	End If
End Sub

Sub UpdatePropertyList(propName As String, xlist As List)
	If EditTV.IsInitialized Then EditTV.UpdatePropertyList(propName, xlist)
End Sub

Sub UpdatePropertyListONLY(propName As String, xlist As List)
	If EditTV.IsInitialized Then EditTV.UpdatePropertyListONLY(propName, xlist)
End Sub

Sub SetProperty(propName As String, propValue As Object)
	If EditTV.IsInitialized Then EditTV.SetProperty(propName,propValue)
End Sub

Sub SetPropertyONLY(propName As String, propValue As Object)
	If EditTV.IsInitialized Then EditTV.SetPropertyONLY(propName,propValue)
End Sub

Sub SetColumnWidth(colCnt As Int,colWidth As Double)
	If EditTV.IsInitialized Then EditTV.SetColumnWidth(colCnt,colWidth)
End Sub

Sub AddLabelProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddLabelProperty(propHeader, propValue , propDescription , propTag )
End Sub

Sub AddButton(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddButton(propHeader, propValue, propDescription, propTag)
End Sub

Sub AddCheckComboBoxProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String, clist As List,bSort As Boolean)
	If EditTV.IsInitialized Then EditTV.AddCheckComboBoxProperty(propHeader, propValue, propDescription, propTag, clist,bSort)
End Sub

'Add textarea property
Sub AddBiggerTextAreaProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddBiggerTextAreaProperty(propHeader,propValue,propDescription,propTag)
End Sub

Sub AddTextBoxProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddTextBoxProperty(propHeader,propValue,propDescription,propTag)
End Sub

Sub AddTextAreaProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddTextAreaProperty(propHeader,propValue,propDescription,propTag)
End Sub

Sub AddDatePickerProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddDatePickerProperty(propHeader, propValue, propDescription, propTag)
End Sub

Sub AddFilePickerProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddFilePickerProperty(propHeader, propValue, propDescription, propTag)
End Sub

Sub AddCheckBoxProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddCheckBoxProperty(propHeader,propValue,propDescription,propTag)
End Sub

Sub AddPasswordProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddPasswordProperty(propHeader, propValue, propDescription, propTag)
End Sub

Sub AddIconPickerProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddIconPickerProperty(propHeader, propValue, propDescription, propTag)
End Sub

Sub AddQueryProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddQueryProperty(propHeader, propValue, propDescription, propTag)
End Sub

Sub AddComboBoxProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String, clist1 As List,bSort As Boolean)
	If EditTV.IsInitialized Then EditTV.AddComboBoxProperty(propHeader,propValue,propDescription,propTag,clist1,bSort)
End Sub

Sub AddComboBoxRefreshProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String, clist1 As List,bSort As Boolean)
	If EditTV.IsInitialized Then EditTV.AddComboBoxRefreshProperty(propHeader,propValue,propDescription,propTag,clist1,bSort)
End Sub

Sub AddImageFileChooserProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddImageFileChooserProperty(propHeader,propValue,propDescription,propTag)
End Sub

'Add a file name chooser property
Sub AddFileNameChooserProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddFileNameChooserProperty(propHeader,propValue,propDescription, propTag)
End Sub

Sub SetPropertyList(propName As String, blist As List)
	If EditTV.IsInitialized Then EditTV.SetPropertyList(propName,blist)
End Sub

Sub SetPropertyListONLY(propName As String, blist As List)
	If EditTV.IsInitialized Then EditTV.SetPropertyListonly(propName,blist)
End Sub

Sub SetPropertyOriginal(propName As String)
	If EditTV.IsInitialized Then EditTV.SetPropertyOriginal(propName)
End Sub

Sub SetPropertyBag(nPropertyBag As Map)
	If EditTV.IsInitialized Then EditTV.SetPropertyBag(nPropertyBag)
End Sub

Sub CRUDOnlyButtons
	btnAdd.visible = True
	btnUpdate.visible = True
	btnDelete.visible = True
	btnClone.visible = True
	btnExport.visible = False
	btnPrint.visible = False
	btnLoadFields.visible = False
	btnToClipboard.visible = False
	btnCopyFromClipboard.visible = False
	btnMakeActive.visible = False
	btnMakeInactive.visible = False
	btnSortRC.visible = False
End Sub

Sub EnableButtons
	Try
		btnAdd.Enabled = True
		btnUpdate.Enabled = True
		btnDelete.Enabled = True
		btnClone.Enabled = True
		btnExport.Enabled = True
		btnPrint.Enabled = True
		btnLoadFields.Enabled = True
		btnToClipboard.Enabled = True
		btnCopyFromClipboard.Enabled = True
		btnMakeActive.Enabled = True
		btnMakeInactive.Enabled = True
		btnSortRC.Enabled = True
		CSSUtils.SetBorder(btnAdd,1,fx.Colors.Green,2)
		CSSUtils.SetBorder(btnUpdate,1,fx.Colors.Green,2)
		CSSUtils.SetBorder(btnDelete,1,fx.Colors.green,2)
		CSSUtils.SetBorder(btnClone,1,fx.Colors.green,2)
		CSSUtils.SetBorder(btnExport,1,fx.Colors.green,2)
		CSSUtils.SetBorder(btnPrint,1,fx.Colors.green,2)
		CSSUtils.SetBorder(btnLoadFields,1,fx.Colors.green,2)
		CSSUtils.SetBorder(btnToClipboard,1,fx.Colors.green,2)
		CSSUtils.SetBorder(btnCopyFromClipboard,1,fx.Colors.green,2)
		CSSUtils.SetBorder(btnMakeActive,1,fx.Colors.green,2)
		CSSUtils.SetBorder(btnMakeInactive,1,fx.Colors.green,2)
		CSSUtils.SetBorder(btnSortRC,1,fx.Colors.Green,2)
	Catch
		LogError("EnableButtons: " & LastException)
		
	End Try
End Sub

Sub EnableActive
	Try
		btnMakeActive.Enabled = True
		btnMakeInactive.Enabled = True
		CSSUtils.SetBorder(btnMakeActive,1,fx.Colors.Green,2)
		CSSUtils.SetBorder(btnMakeInactive,1,fx.Colors.Green,2)
	Catch
		LogError("EnableActive: " & LastException)
		
	End Try
End Sub

Sub EnableUpdate
	Try
		btnUpdate.Enabled = True
		CSSUtils.SetBorder(btnUpdate,1,fx.Colors.Green,2)
	Catch
		LogError("EnableUpdate: " & LastException)
		
	End Try
End Sub

Sub DisableButtons
	Try
		btnAdd.Enabled = False
		btnUpdate.Enabled = False
		btnDelete.Enabled = False
		btnClone.Enabled = False
		btnExport.Enabled = False
		btnPrint.Enabled = False
		btnLoadFields.Enabled = False
		btnToClipboard.Enabled = False
		btnCopyFromClipboard.Enabled = False
		btnMakeActive.Enabled = False
		btnMakeInactive.Enabled = False
		btnSortRC.Enabled = False
		CSSUtils.SetBorder(btnAdd,1,fx.Colors.red,2)
		CSSUtils.SetBorder(btnUpdate,1,fx.Colors.red,2)
		CSSUtils.SetBorder(btnDelete,1,fx.Colors.red,2)
		CSSUtils.SetBorder(btnClone,1,fx.Colors.red,2)
		CSSUtils.SetBorder(btnExport,1,fx.Colors.red,2)
		CSSUtils.SetBorder(btnPrint,1,fx.Colors.red,2)
		CSSUtils.SetBorder(btnLoadFields,1,fx.Colors.red,2)
		CSSUtils.SetBorder(btnToClipboard,1,fx.Colors.red,2)
		CSSUtils.SetBorder(btnCopyFromClipboard,1,fx.Colors.red,2)
		CSSUtils.SetBorder(btnMakeActive,1,fx.Colors.red,2)
		CSSUtils.SetBorder(btnMakeInactive,1,fx.Colors.red,2)
		CSSUtils.SetBorder(btnSortRC,1,fx.Colors.Red,2)
	Catch
		LogError("DisableButtons: " & LastException)
		
	End Try
End Sub

Sub  GetProperty(propName As String) As Object
	Return EditTV.GetProperty(propName)
End Sub

Sub GetKeys As List
	'kvs.Initialize(File.dirtemp,SavePath)
	Return kvs.ListKeys
End Sub

Sub KeyExist(sPropName As String) As Boolean
	Dim lst As List = GetKeys
	For Each strItem As String In lst
		If strItem.EqualsIgnoreCase(sPropName) Then
			Return True
		End If
	Next
	Return False
End Sub

Sub HideDescriptionColumn
	'EditTV.HideDescriptionColumn
End Sub

'saving the records externally seems to be the only option for now, we need this
Sub SetSavePath(saveP As String)
	SavePath = saveP
	kvs.Initialize(File.dirtemp,saveP)
	SavePather = saveP & ".txt"
	If File.exists(File.dirtemp,SavePather) Then File.Delete(File.dirtemp,SavePather)
	Clear
End Sub

Sub SetParentForm(frm As Object)
	ParentForm = frm
	If EditTV.IsInitialized Then EditTV.SetParentForm(frm)
End Sub

Sub Clear
	kvs.DeleteAll
	lvKeys.Items.clear
	If EditTV.IsInitialized Then EditTV.Reset
End Sub

Sub CreateList(Delimiter As String, Values As String) As List
	If EditTV.IsInitialized Then
		Return EditTV.CreateList(Delimiter,Values)
	Else
		Dim xy As List
		xy.Initialize
		Return xy
	End If
End Sub

Sub AddToggleButtonProperty(propHeader As String, propValue As String, propDescription As String, propTag As String, offText As String, onText As String)
	If EditTV.IsInitialized Then EditTV.AddToggleButtonProperty(propHeader, propValue, propDescription, propTag, offText, onText)
End Sub

Sub AddToggleButtonIconProperty(propHeader As String, propValue As String, propDescription As String, propTag As String, offText As String, onText As String)
	If EditTV.IsInitialized Then EditTV.AddToggleButtonIconProperty(propHeader, propValue, propDescription, propTag, offText, onText)
End Sub

Sub AddRadioButtonProperty(propHeader As String, propValue As Object, propDescription As String, propTag As String, zlist As List,bSort As Boolean)
	If EditTV.IsInitialized Then EditTV.AddRadioButtonProperty(propHeader, propValue, propDescription, propTag, zlist,bSort)
End Sub

Sub AddButtonIcon(propHeader As String, propValue As Object, propDescription As String, propTag As String)
	If EditTV.IsInitialized Then EditTV.AddButtonIcon(propHeader, propValue, propDescription, propTag)
End Sub

Sub AddLabelProperty1(propHeader As String)
	If EditTV.IsInitialized Then EditTV.AddLabelProperty1(propHeader)
End Sub

Sub AddSaveButton()
	If EditTV.IsInitialized Then EditTV.AddSaveButton()
End Sub

Sub AddSaveDeleteButton
	If EditTV.IsInitialized Then EditTV.AddSaveDeleteButton
End Sub

Sub SortIt
	Dim keys As List = kvs.ListKeys
	lvKeys.Items.clear
	keys.Sort(ShouldSort)
	For Each strKey As String In keys
		ListViewAddText(lvKeys,strKey)
	Next
End Sub

'load from a saved matching json string
Sub Load(Value As String, lSize As Int, lMax As Int)
	SetLoading(True)
	'kvs.Initialize(File.dirtemp,SavePath)
	If ReadOnly.Size >= 1 Then SetReadOnly(ReadOnly)
	minSize = lSize
	maxSize = lMax
	PrimaryKey = PrimaryKey.ToLowerCase
	SecondaryKey = SecondaryKey.tolowercase
	If lSize <> -1 And lMax <> -1 Then
		SetListViewSize(lSize,lMax)
	End If
	'clear the contents of the kvs
	Clear
	If Value = "null" Or Value = "[]" Or Value = "" Then
		SetLoading(False)
		Return
	End If
	Dim hList As List
	If Value.Length > 0 Then
		hList = Json2List(Value)
		Dim hTot As Int
		Dim hCnt As Int
		Dim hTxt As String
		Dim hTxt1 As String
		Dim hMap As Map
		hTot = hList.Size - 1
		For hCnt = 0 To hTot
			hMap = hList.Get(hCnt)
			hTxt = hMap.Getdefault(PrimaryKey,"")
			If SecondaryKey.Length > 0 Then
				hTxt = MvField(hTxt,1,".")
				hTxt1 = hMap.Getdefault(SecondaryKey,"")
				hTxt = $"${hTxt}.${hTxt1}"$
				'hMap.Put(PrimaryKey,hTxt)
			End If
			If hTxt.Length > 0 Then
				kvs.PutObject(hTxt,hMap)
			End If
		Next
		SortIt
	End If
	SetLoading(False)
	Try
		'save to temporal storage
		If SavePather <> "" Then File.WriteString(File.dirtemp,SavePather,Value)
	Catch
		LogError("Load: " & LastException)
	End Try
End Sub

Sub MvField(sValue As String, iPosition As Int, Delimiter As String) As String
	If sValue.Length = 0 Then Return ""
	Delimiter = FixDelimiter(Delimiter)
	Dim xPos As Int: xPos = sValue.IndexOf(Delimiter)
	If xPos = -1 Then Return sValue
	Dim mValues() As String
	Dim tValues As Int
	If sValue.EndsWith(Delimiter) Then sValue = sValue & " "
	mValues = Regex.split(Delimiter, sValue)
	tValues = mValues.Length -1
	Select Case iPosition
		Case -1
			Return mValues(tValues)
		Case -2
			Return mValues(tValues - 1)
		Case -3
			Dim sb As StringBuilder
			sb.Initialize
			Dim startcnt As Int
			For startcnt = 1 To tValues
				sb.Append(mValues(startcnt)).append(Delimiter)
			Next
			sb.Remove(sb.Length-Delimiter.Length,sb.Length)
			Return sb.tostring
		Case Else
			iPosition = iPosition - 1
			If iPosition <= -1 Then Return mValues(tValues)
			If iPosition > tValues Then Return ""
			Return mValues(iPosition)
	End Select
End Sub

Sub FixDelimiter(sValue As String) As String
	If sValue = "|" Then sValue = "\|"
	If sValue = "." Then sValue = "\."
	If sValue = "\" Then sValue = "\\"
	If sValue = "^" Then sValue = "\^"
	If sValue = "$" Then sValue = "\$"
	If sValue = "?" Then sValue = "\?"
	If sValue = "*" Then sValue = "\*"
	If sValue = "+" Then sValue = "\+"
	If sValue = "(" Then sValue = "\("
	If sValue = ")" Then sValue = "\)"
	If sValue = "[" Then sValue = "\["
	If sValue = "{" Then sValue = "\{"
	If sValue = ";" Then sValue = "\;"
	Return sValue
End Sub

Sub NewRecord(mRecord As Map)
	Dim hTxt As String = mRecord.Getdefault(PrimaryKey.ToLowerCase,"")
	If SecondaryKey.Length > 0 Then
		hTxt = MvField(hTxt,1,".")
		hTxt1 = mRecord.Getdefault(SecondaryKey.ToLowerCase,"")
		hTxt = $"${hTxt}.${hTxt1}"$
		'mRecord.Put(PrimaryKey.ToLowerCase,hTxt)
	End If
	If hTxt.Length > 0 Then
		'kvs.Initialize(File.dirtemp,SavePath)
		kvs.PutObject(hTxt,mRecord)
	End If
	SortIt
End Sub

Sub SetSizes
	SetListViewSize(minSize,maxSize)
	If EditTV.IsInitialized Then EditTV.SetLoading(False)
End Sub

'return a list from a json string
Sub Json2List(strValue As String) As List
	Dim lst As List
	lst.Initialize
	If strValue.Length = 0 Then
		Return lst
	End If
	Try
		Dim parser As JSONParser
		parser.Initialize(strValue)
		Return parser.NextArray
	Catch
		Return lst
	End Try
End Sub

'convert a map to json string
private Sub Map2Json(Value As Map) As String
	Dim sOut As String
	Dim jsonGen As JSONGenerator
	jsonGen.Initialize(Value)
	sOut = jsonGen.ToString
	Return sOut
End Sub

'convert a list to a json string
private Sub List2JSON(lst As List) As String
	Dim sOut As String
	Dim jsonGen As JSONGenerator
	jsonGen.Initialize2(lst)
	sOut = jsonGen.ToString
	Return sOut
End Sub


Sub Len(Text As String) As Int
	Return Text.Length
End Sub

private Sub CLng(o As Object) As Long
	Try
		Dim ox As String = o
		ox = GetNumbers(ox)
		If ox = "" Then ox = "0"
		Return Floor(ox)
	Catch
		Return 0
	End Try
End Sub

Sub GetNumbers(value As String) As String
	Dim strCnt As Int
	Dim str As String
	Dim sb As StringBuilder
	sb.Initialize
	Dim master As String = "0123456789.-"
	For strCnt = 0 To value.Length - 1
		str = value.CharAt(strCnt)
		If master.IndexOf(str) >= 0 Then
			sb.Append(str)
		End If
	Next
	Return sb.tostring
End Sub

private Sub CInt(o As Object) As Int
	Try
		Dim ox As String = o
		ox = GetNumbers(ox)
		If ox = "" Then ox = "0"
		Return Floor(ox)
	Catch
		Return 0
	End Try
End Sub

Sub PadRight(Value As String, MaxLen As Int, PadChar As String) As String
	Dim intOrdNoLen As Int = Len(Value)
	Dim i As Int
	For i = 1 To (MaxLen - intOrdNoLen) Step 1
		Value = PadChar & Value
	Next
	Return Value
End Sub

Sub MaxOfList(lst As List) As Int
	Dim maxcnt As Int = 0
	Dim curCnt As Int = 0
	For Each strID As String In lst
		curCnt = CInt(strID)
		If curCnt > maxcnt Then maxcnt = curCnt
	Next
	Return maxcnt
End Sub

Sub NextSequence As String
	Try
		'kvs.Initialize(File.dirtemp,SavePath)
		Dim lst As List = kvs.ListKeys
		Dim rcnt As String = lst.Size + 1
		rcnt = PadRight(rcnt,2,"0")
		Return rcnt
	Catch
		Return PadRight(1,2,"0")
	End Try
End Sub

Sub ToList As List
	'kvs.Initialize(File.dirtemp,SavePath)
	Dim lst As List = kvs.ListObjects(ShouldSort)
	Return lst
End Sub


'return the listview json result for storage
Public Sub ToString() As String
	Dim lJSON As String
	Dim lList As List
	'kvs.Initialize(File.dirtemp,SavePath)
	lList = kvs.ListObjects(ShouldSort)
	lJSON = List2JSON(lList)
	If lJSON = "[]" Then lJSON = ""
	Return lJSON
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
	ShouldSort = True
	GetLastUpdated.initialize
	GetLastDeleted.initialize
	ReadOnly.Initialize
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	Base.LoadLayout("frmSplitPane")
	vSplit.LoadLayout("frmListView")
	vSplit.LoadLayout("frmEditor")
	CRUDOnly = Props.GetDefault("CRUDOnly",False)
	If CRUDOnly = True Then
		btnClone.Visible = False
		btnExport.Visible = False
		btnPrint.Visible = False
		btnLoadFields.Visible = False
		btnToClipboard.Visible = False
		btnCopyFromClipboard.Visible = False
		btnMakeActive.Visible = False
		btnMakeInactive.Visible = False
	End If
End Sub

Sub SetCRUDOnly
	btnClone.Visible = False
	btnExport.Visible = False
	btnPrint.Visible = False
	btnLoadFields.Visible = False
	btnToClipboard.Visible = False
	btnCopyFromClipboard.Visible = False
	btnMakeActive.Visible = False
	btnMakeInactive.Visible = False
End Sub

Sub SetWidths(intLeft As Int, intMiddle As Int)
	SetListViewSize(intLeft,intLeft)
	If EditTV.IsInitialized Then EditTV.SetColumnWidth(1,intMiddle)
End Sub

Sub SetListViewSize(intMin As Double, intMax As Double)
	minSize = intMin
	maxSize = intMax
	vSplit.SetSizeLimits(0, intMin, intMax)
	If EditTV.IsInitialized Then EditTV.SetColumnWidth(0,intMin)
End Sub

Sub SetListViewSize1(intMin As Double, intMax As Double)
	minSize = intMin
	maxSize = intMax
	vSplit.SetSizeLimits(1, intMin, intMax)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	vSplit.SetLayoutAnimated(0, 0, 0, Width, Height)
	'Dim spc As Int
	'spc = EditTV.GetWidth / 4
	'btnAdd.prefWidth = spc
	'btnUpdate.prefWidth = spc
	'btnDelete.prefWidth = spc
	'spc = (EditTV.getWidth - (btnAdd.width + btnUpdate.width + btnDelete.width)) / 4
	'btnAdd.left = spc
	'btnUpdate.left = btnAdd.left + btnUpdate.width + spc
	'btnDelete.left = btnUpdate.left + btnUpdate.width + spc
End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub

'the update button has been clicked to add a new entry
Sub btnUpdate_Action
	Try
		' find it the song url exists in the list
		If PrimaryKey.Length = 0 Then
			LogError("PrimaryKey error")
			Return
		End If
		PrimaryKey = PrimaryKey.ToLowerCase
		SecondaryKey = SecondaryKey.tolowercase
		'ensure we have the latest content
		Dim pb As Map = EditTV.GetPropertyBag
		GetLastUpdated = pb
		PrimaryValue = pb.GetDefault(PrimaryKey,"")
		If SecondaryKey.Length > 0 Then
			PrimaryValue = MvField(PrimaryValue,1,".")
			hTxt1 = pb.getdefault(SecondaryKey,"")
			PrimaryValue = $"${PrimaryValue}.${hTxt1}"$
			'pb.Put(PrimaryKey,PrimaryValue)
		End If
		'process conditions for this record
		'kvs.Initialize(File.dirtemp,SavePath)
		If kvs.PutObject(PrimaryValue, pb) = True Then
			' delete old value
			SortIt
			Dim sout As String = ToString
			Dim soute As String = Map2Json(pb)
			'save to temporal storage
			File.WriteString(File.dirtemp,SavePather,sout)
			'call event for further processing
			If SubExists(CallBack, EventName & "_ItemUpdated") Then
				CallSub3(CallBack, EventName & "_ItemUpdated", sout, soute)
			End If
		Else
			'load old records
			Dim sout As String = File.ReadString(File.dirtemp,SavePather)
			Load(sout,minSize,maxSize)
		End If
	Catch
		LogError("btnUpdate_Action: " & LastException)
		
	End Try
End Sub

private Sub ListViewAddText(lv As ListView, Line1 As String)
	' only add if the item does not exist
	Dim pos As Int = ListViewTextPos(lv,Line1)
	If pos = -1 Then
		Dim ap As AnchorPane
		ap.Initialize(Line1)
		Dim lbl1 As Label
		lbl1.Initialize(Line1)
		lbl1.Text = Line1
		lbl1.Font = fx.DefaultFont(12)
		lbl1.Tag = Line1
		ap.AddNode(lbl1, 0, 0, lv.Width, 20dip)
		ap.Tag = Line1
		lv.Items.Add(ap)
	End If
End Sub

'find an item at a position
private Sub ListViewTextPos(lstView As ListView, searchText As String) As Int
	Dim ap As AnchorPane
	Dim title As Label
	Dim t As Int
	Dim i As Int
	Dim tg As String
	searchText = searchText.ToLowerCase
	t = lstView.items.Size - 1
	For i = 0 To t
		ap = lstView.Items.Get(i)
		title = ap.GetNode(0)
		tg = title.text
		tg = tg.ToLowerCase
		If tg = searchText Then
			Return i
		End If
	Next
	Return -1
End Sub

'remove item by text
private Sub ListViewRemoveByText(lstView As ListView, searchText As String)
	Dim i As Int
	i = ListViewTextPos(lstView,searchText)
	If i <> -1 Then lstView.Items.RemoveAt(i)
End Sub

'delete button selected
Sub btnDelete_Action
	If PrimaryKey.Length = 0 Then
		LogError("PrimaryKey error")
		Return
	End If
	Dim res As Int = fx.Msgbox2(ParentForm, "Do you want to delete this entry? You will not be able to undo your action. Continue?", "Delete", _
   "Yes", "Cancel", "No", fx.MSGBOX_WARNING)
	If res = fx.DialogResponse.POSITIVE Then
		Try
			PrimaryKey = PrimaryKey.ToLowerCase
			SecondaryKey = SecondaryKey.tolowercase
			GetLastDeleted = EditTV.GetPropertyBag
			PrimaryValue = GetLastDeleted.GetDefault(PrimaryKey,"")
			If SecondaryKey.Length > 0 Then
				PrimaryValue = MvField(PrimaryValue,1,".")
				hTxt1 = GetLastDeleted.getdefault(SecondaryKey,"")
				PrimaryValue = $"${PrimaryValue}.${hTxt1}"$
				'GetLastDeleted.Put(PrimaryKey,PrimaryValue)
			End If
			'kvs.Initialize(File.dirtemp,SavePath)
			kvs.Remove(PrimaryValue)
			SortIt
			Dim sout As String = ToString
			'later processing
			If SubExists(CallBack, EventName & "_ItemDeleted") Then
				CallSub3(CallBack, EventName & "_ItemDeleted", sout, GetLastDeleted)
			End If
		Catch
			LogError("btnDelete_Action: " & LastException)
		
		End Try
	End If
End Sub

Sub AddRecord
	btnAdd_Action
End Sub

'reset for entry
Sub btnAdd_Action
	Try
		EditTV.reset
		PrimaryKey = PrimaryKey.ToLowerCase
		SecondaryKey = SecondaryKey.tolowercase
		'incremement the primary key
		Dim nc As String = NextSequence
		SetPropertyONLY(PrimaryKey, nc)
		SetPropertyONLY("tabindex", nc)
		Refresh
		SetListViewSize(minSize,maxSize)
		EditTV.TV.ScrollTo(0)
		If SubExists(CallBack, EventName & "_ItemNew") Then
			CallSub(CallBack, EventName & "_ItemNew")
		End If
	Catch
		LogError("btnAdd_Action: " & LastException)
	End Try
End Sub

'return a tag at a location
private Sub ListViewGetItemTag(lstView As ListView, idxPos As Int) As Map
	Dim ap As AnchorPane
	Dim title As Label
	ap = lstView.items.Get(idxPos)
	title = ap.GetNode(0)
	Return title.tag
End Sub

private Sub ListViewGetItemText(lstView As ListView, idxPos As Int) As String
	Dim ap As AnchorPane
	Dim title As Label
	ap = lstView.items.Get(idxPos)
	title = ap.GetNode(0)
	Return title.text
End Sub

Sub Json2Map(jsonText As String) As Map
	Dim json As JSONParser
	Dim Map1 As Map
	Map1.Initialize
	Try
		If Len(jsonText) > 0 Then
			json.Initialize(jsonText)
			Map1 = json.NextObject
		End If
		Map1 = MapRemoveNulls(Map1)
		Return Map1
	Catch
		Return Map1
	End Try
End Sub

Sub MapRemoveNulls(dm As Map) As Map
	Dim tmpMap As Map
	Dim strValue As String
	tmpMap.Initialize
	For Each strKey As String In dm.Keys
		If dm.GetDefault(strKey,Null) = Null Then
			strValue = ""
		Else
			strValue = dm.Get(strKey)
		End If
		tmpMap.Put(strKey,strValue)
	Next
	Return tmpMap
End Sub

Sub GetValue(bagJSON As String, Key As String) As String
	Dim m As Map = Json2Map(bagJSON)
	Key = Key.ToLowerCase
	Return m.GetDefault(Key,"")
End Sub

Sub EditTV_FileSelected (Property As String, Value As String)
	'file has been selected, later processing
	Try
		If SubExists(CallBack, EventName & "_FileSelected") Then
			CallSub3(CallBack, EventName & "_FileSelected", Property, Value)
		End If
	Catch
		LogError("EditTV_FileSelected: " & LastException)
		
	End Try
End Sub

Sub EditTV_Query (Property As String, Value As String)
	'file has been selected, later processing
	Try
		If SubExists(CallBack, EventName & "_Query") Then
			CallSub3(CallBack, EventName & "_Query", Property, Value)
		End If
	Catch
		LogError("EditTV_Query: " & LastException)		
	End Try
End Sub

Sub EditTV_Update (RowIndex As Int, Value As Map)
	'file has been selected, later processing
	Try
		If SubExists(CallBack, EventName & "_Update") Then
			CallSub3(CallBack, EventName & "_Update", RowIndex, Value)
		End If
	Catch
		LogError("EditTV_Update: " & LastException)
	End Try
End Sub

Sub EditTV_Delete (RowIndex As Int, Value As Map)
	'file has been selected, later processing
	Try
		If SubExists(CallBack, EventName & "_Delete") Then
			CallSub3(CallBack, EventName & "_Delete", RowIndex, Value)
		End If
	Catch
		LogError("EditTV_Delete: " & LastException)
	End Try
End Sub


'Sub EditTV_CheckBoxChanged (Property As String, Value As Boolean)
'	'file has been selected, later processing
'	Try
'		If SubExists(CallBack, EventName & "_CheckBoxChanged") Then
'			CallSub3(CallBack, EventName & "_CheckBoxChanged", Property, Value)
'		End If
'	Catch
'		LogError("EditTV_CheckBoxChanged: " & LastException)
'		
'	End Try
'End Sub

Sub EditTV_ComboChanged (Property As String, Value As Object)
	'file has been selected, later processing
	Try
		If SubExists(CallBack, EventName & "_ComboChanged") Then
			CallSub3(CallBack, EventName & "_ComboChanged", Property, Value)
		End If
	Catch
		LogError("EditTV_ComboChanged: " & LastException)
		
	End Try
End Sub

'Sub EditTV_ComboButton (Property As String)
'	'file has been selected, later processing
'	Try
'		If SubExists(CallBack, EventName & "_ComboButton") Then
'			CallSub2(CallBack, EventName & "_ComboButton", Property)
'		End If
'	Catch
'		LogError("EditTV_ComboButton: " & LastException)
'	End Try
'End Sub

Sub EditTV_IconPicker (Property As String, Value As String)
	Try
		If SubExists(CallBack, EventName & "_IconPicker") Then
			CallSub3(CallBack, EventName & "_IconPicker", Property, Value)
		End If
	Catch
		LogError("EditTV_IconPicker: " & LastException)
		
	End Try
End Sub

Sub GetPropertyHex(propName As String) As String
	Try
		Return EditTV.GetPropertyHex(propName)
	Catch
		Return ""
	End Try
End Sub

'Sub EditTV_ColorChanged (Property As String, Value As Object)
'	Try
'		If SubExists(CallBack, EventName & "_ColorChanged") Then
'			CallSub3(CallBack, EventName & "_ColorChanged", Property, Value)
'		End If
'	Catch
'		LogError("EditTV_ColorChanged: " & LastException)
'		
'	End Try
'End Sub

Sub EditTV_Clicked (Property As String, Value As Map)
	'file has been selected, later processing
	Try
		If SubExists(CallBack, EventName & "_Clicked") Then
			CallSub3(CallBack, EventName & "_Clicked", Property, Value)
		End If
	Catch
		LogError("EditTV_Clicked: " & LastException)
	End Try
End Sub

Sub EditTV_FieldSelect (Property As String, Value As String)
	'file has been selected, later processing
	Try
		If SubExists(CallBack, EventName & "_FieldSelect") Then
			CallSub3(CallBack, EventName & "_FieldSelect", Property, Value)
		End If
	Catch
		LogError("EditTV_FieldSelect: " & LastException)
		
	End Try
End Sub


'Sub EditTV_TextAreaChanged (Property As String, TagOldNewMap As Map)
'	Try
'		If SubExists(CallBack, EventName & "_TextAreaChanged") Then
'			CallSub3(CallBack, EventName & "_TextAreaChanged", Property, TagOldNewMap)
'		End If
'	Catch
'		LogError("EditTV_TextAreaChanged: " & LastException)
'		
'	End Try
'End Sub

'Sub EditTV_TextFieldChanged (Property As String, TagOldNewMap As Map)
'	Try
'		If SubExists(CallBack, EventName & "_TextFieldChanged") Then
'			CallSub3(CallBack, EventName & "_TextFieldChanged", Property, TagOldNewMap)
'		End If
'	Catch
'		LogError("EditTV_TextFieldChanged: " & LastException)
'		
'	End Try
'End Sub

'Sub EditTV_DatePickerValueChanged (Property As String, Value As Long)
'	Try
'		If SubExists(CallBack, EventName & "_DatePickerValueChanged") Then
'			CallSub3(CallBack, EventName & "_DatePickerValueChanged", Property, Value)
'		End If
'	Catch
'		LogError("EditTV_DatePickerValueChanged: " & LastException)
'		
'	End Try
'End Sub

'Sub EditTV_ToggleButton (Property As String, Value As Boolean)
'	Try
'		If SubExists(CallBack, EventName & "_ToggleButton") Then
'			CallSub3(CallBack, EventName & "_ToggleButton", Property, Value)
'		End If
'	Catch
'		LogError("EditTV_ToggleButton: " & LastException)
'	End Try
'End Sub


'Sub EditTV_SpinnerValueChanged (Property As String, Value As Object)
'	Try
'		If SubExists(CallBack, EventName & "_SpinnerValueChanged") Then
'			CallSub3(CallBack, EventName & "_SpinnerValueChanged", Property, Value)
'		End If
'	Catch
'		LogError("EditTV_SpinnerValueChanged: " & LastException)
'	End Try
'End Sub

'Sub EditTV_SliderValueChange (Property As String, Value As Double)
'	Try
'		If SubExists(CallBack, EventName & "_SliderValueChange") Then
'			CallSub3(CallBack, EventName & "_SliderValueChange", Property, Value)
'		End If
'	Catch
'		LogError("EditTV_SliderValueChange: " & LastException)
'	End Try
'End Sub


'Sub EditTV_RadioButton (Property As String, Value As String)
'	Try
'		If SubExists(CallBack, EventName & "_RadioButton") Then
'			CallSub3(CallBack, EventName & "_RadioButton", Property, Value)
'		End If
'	Catch
'		LogError("EditTV_RadioButton: " & LastException)
'	End Try
'End Sub

'Sub EditTV_Switch (Property As String, Value As Boolean)
'	Try
'		If SubExists(CallBack, EventName & "_Switch") Then
'			CallSub3(CallBack, EventName & "_Switch", Property, Value)
'		End If
'	Catch
'		LogError("EditTV_Switch: " & LastException)
'	End Try
'End Sub


'return all tags as a map
private Sub ListViewGetTags(lstView As ListView) As List
	Dim ap As AnchorPane
	Dim title As Label
	Dim l As List
	Dim t As Int
	Dim i As Int
	l.Initialize
	' get all the items from the list
	t = lstView.items.Size - 1
	' loop through each item
	For I = 0 To t
		ap = lstView.items.Get(I)
		title = ap.GetNode(0)
		l.Add(title.Tag)
	Next
	Return l
End Sub

'set the tag map at a location
private Sub ListViewSetItemTag(lstView As ListView, idxPos As Int, Value As Object)
	Dim ap As AnchorPane
	Dim title As Label
	ap = lstView.items.Get(idxPos)
	title = ap.GetNode(0)
	title.tag = Value
	ap.Tag = Value
End Sub

'add one line with a tag
private Sub ListViewAddOneLine(lv As ListView, Line1 As String, Value As Object)
	Dim ap As AnchorPane
	ap.Initialize(Line1)
	Dim lbl1 As Label
	lbl1.Initialize(Line1)
	lbl1.Text = Line1
	lbl1.Font = fx.DefaultFont(12)
	lbl1.Tag = Value
	ap.AddNode(lbl1, 0, 0, lv.Width, 20dip)
	ap.Tag = Value
	lv.Items.Add(ap)
End Sub

Sub btnClone_Action
	' find it the song url exists in the list
	Try
		If PrimaryKey.Length = 0 Then
			LogError("PrimaryKey error")
			Return
		End If
		PrimaryKey = PrimaryKey.ToLowerCase
		SecondaryKey = SecondaryKey.tolowercase
		Dim nc As String = NextSequence
		'ensure we have the latest content
		GetLastDeleted = EditTV.GetPropertyBag
		PrimaryValue = nc
		If SecondaryKey.Length > 0 Then
			PrimaryValue = MvField(PrimaryValue,1,".")
			hTxt1 = GetLastDeleted.GetDefault(SecondaryKey,"")
			PrimaryValue = $"${PrimaryValue}.${hTxt1}"$
			'GetLastDeleted.Put(PrimaryKey,PrimaryValue)
		End If
		EditTV.SetPropertyonly(PrimaryKey,PrimaryValue)
		EditTV.SetPropertyonly("tabindex", nc)
		EditTV.refresh
		'kvs.Initialize(File.dirtemp,SavePath)
		If kvs.PutObject(PrimaryValue, GetLastDeleted) = True Then
			SortIt
			Dim sout As String = Map2Json(GetLastDeleted)
			'call event for further processing
			If SubExists(CallBack, EventName & "_ItemCloned") Then
				CallSub2(CallBack, EventName & "_ItemCloned", sout)
			End If
		Else
			If SubExists(CallBack, EventName & "_ItemError") Then
				CallSub2(CallBack, EventName & "_ItemError", sout)
			End If
		End If
	Catch
		LogError("btnClone_Action: " & LastException)
		
	End Try
End Sub

Sub btnToClipboard_Action
	Dim str As String = ToString
	fx.Clipboard.SetString(str)
	'call event for further processing
	Try
		If SubExists(CallBack, EventName & "_ItemCopied") Then
			CallSub2(CallBack, EventName & "_ItemCopied", str)
		End If
	Catch
		LogError("btnToClipboard_Action: " & LastException)
		
	End Try
End Sub

Sub btnCopyFromClipboard_Action
	Dim str As String = fx.Clipboard.GetString
	If str.Length > 0 Then Load(str,250,300)
End Sub

Sub btnImport_Action
	
End Sub

Sub ClearConditions
	If EditTV.IsInitialized Then EditTV.ClearConditions
End Sub

Sub AddCondition(Property2Test As String, TestValue As String, Property2Set As String, SetValue As String, OverWrite As Boolean, GetFromAnotherProperty As Boolean)
	If EditTV.IsInitialized Then EditTV.AddCondition(Property2Test,TestValue,Property2Set,SetValue, OverWrite, GetFromAnotherProperty)
End Sub

Sub OpenFile(sPath As String)
	If File.Exists("",sPath) = True Then
		fx.ShowExternalDocument(File.GetUri("",sPath))
	End If
End Sub

Sub btnExport_Action
	' find it the song url exists in the list
	If PrimaryKey.Length = 0 Then
		LogError("PrimaryKey error")
		Return
	End If
	Try
		PrimaryKey = PrimaryKey.ToLowerCase
		SecondaryKey = SecondaryKey.tolowercase
		'ensure we have the latest content
		Dim pb As Map = EditTV.GetPropertyBag
		PrimaryValue = pb.getdefault(PrimaryKey,"")
		If SecondaryKey.Length > 0 Then
			PrimaryValue = MvField(PrimaryValue,1,".")
			hTxt1 = pb.getdefault(SecondaryKey,"")
			PrimaryValue = $"${PrimaryValue}.${hTxt1}"$
			'pb.Put(PrimaryKey,PrimaryValue)
		End If
		Dim sout As String = Map2Json(pb)
		File.WriteString(File.dirapp, PrimaryValue & ".json", sout)
		OpenFile(File.Combine(File.DirApp,PrimaryValue & ".json"))
		'call event for further processing
		If SubExists(CallBack, EventName & "_ItemExported") Then
			CallSub2(CallBack, EventName & "_ItemExported", sout)
		End If
	Catch
		LogError("btnExport_Action: " & LastException)
		
	End Try
End Sub

Sub btnLoadFields_Action
	Try
		If SubExists(CallBack, EventName & "_LoadFields") Then
			CallSub(CallBack, EventName & "_LoadFields")
		End If
	Catch
		LogError("btnLoadFields_Action: " & LastException)
		
	End Try
End Sub

Sub btnPrint_Action
	'print the editable listview
	If EditTV.IsInitialized Then EditTV.Print2PDF(File.Dirapp,"PropertyBag", EditTV.appname, "Property Bag","Entities")
End Sub

Sub btnMakeActive_Action
	Try
		PrimaryKey = PrimaryKey.ToLowerCase
		SecondaryKey = SecondaryKey.tolowercase
		Dim nList As List
		nList.initialize
		Dim lItems As List = ToList
		For Each mItem As Map In lItems
			mItem.Put("propactive","1")
			mItem.Put("active","1")
			nList.Add(mItem)
		Next
		Dim nItems As String = List2JSON(nList)
		Load(nItems,minSize,maxSize)
		If SubExists(CallBack, EventName & "_MakeActive") Then
			CallSub2(CallBack, EventName & "_MakeActive", ToString)
		End If
	Catch
		LogError("btnMakeActive_Action: " & LastException)
		
	End Try
End Sub

Sub btnMakeInactive_Action
	Try
		PrimaryKey = PrimaryKey.ToLowerCase
		SecondaryKey = SecondaryKey.tolowercase
		Dim nList As List
		nList.initialize
		Dim lItems As List = ToList
		For Each mItem As Map In lItems
			'ensure the intialized method is always left out.
			If mItem.Get(PrimaryKey.ToLowerCase) = "initialized" Then
				mItem.Put("propactive","1")
				mItem.Put("active","1")
			Else
				mItem.Put("propactive","0")
				mItem.Put("active","0")
			End If
			nList.Add(mItem)
		Next
		Dim nItems As String = List2JSON(nList)
		Load(nItems,minSize,maxSize)
		If SubExists(CallBack, EventName & "_MakeInactive") Then
			CallSub2(CallBack, EventName & "_MakeInactive", ToString)
		End If
	Catch
		LogError("btnMakeInactive_Action: " & LastException)
		
	End Try
End Sub

Sub GetPrimaryKeys() As List
	'kvs.Initialize(File.dirtemp,SavePath)
	Return kvs.ListKeys
'	Dim outList As List
'	outList.Initialize
'	If PrimaryKey.Length = 0 Then Return outList
'	Dim lItems As List = Json2List(ToString)
'	For Each recMap As Map In lItems
'		Dim strKey As String = recMap.GetDefault(PrimaryKey,"")
'		If SecondaryKey.Length > 0 Then
'			strKey = MvField(strKey,1,".")
'			hTxt1 = recMap.GetDefault(SecondaryKey.tolowercase,"")
'			strKey = $"${strKey}.${hTxt1}"$
'		End If
'		outList.Add(strKey)
'	Next
'	Return outList
End Sub

Sub GetRecord(sPrimaryValue As String) As Map
	'kvs.Initialize(File.dirtemp,SavePath)
	Return kvs.getobject(sPrimaryValue)
'	Dim outList As Map
'	outList.Initialize
'	If PrimaryKey.Length = 0 Then Return outList
'	Dim lItems As List = Json2List(ToString)
'	For Each recMap As Map In lItems
'		Dim strKey As String = recMap.GetDefault(PrimaryKey,"")
'		If SecondaryKey.Length > 0 Then
'			strKey = MvField(strKey,1,".")
'			hTxt1 = recMap.GetDefault(SecondaryKey.tolowercase,"")
'			strKey = $"${strKey}.${hTxt1}"$
'		End If
'		If strKey.EqualsIgnoreCase(sPrimaryValue) Then
'			Return recMap
'		End If
'	Next
'	Return outList
End Sub

Sub GetPropertyValues(sProperty As String) As List
	Dim outList As List
	outList.Initialize
	If sProperty.Length = 0 Then Return outList
	Dim lItems As List = Json2List(ToString)
	For Each recMap As Map In lItems
		Dim strKey As String = recMap.GetDefault(sProperty.tolowercase,"")
		outList.Add(strKey)
	Next
	Return outList
End Sub

'update the current record
Sub UpdateCurrentRecord
	Try
		PrimaryKey = PrimaryKey.ToLowerCase
		SecondaryKey = SecondaryKey.tolowercase
		Dim pb As Map = EditTV.GetPropertyBag
		PrimaryValue = EditTV.GetProperty(PrimaryKey)
		If SecondaryKey.Length > 0 Then
			PrimaryValue = MvField(PrimaryValue,1,".")
			hTxt1 = EditTV.getproperty(SecondaryKey)
			PrimaryValue = $"${PrimaryValue}.${hTxt1}"$
			'pb.Put(PrimaryKey,PrimaryValue)
		End If
		'kvs.Initialize(File.dirtemp,SavePath)
		kvs.PutObject(PrimaryValue,pb)
	Catch
		LogError("UpdateCurrentRecord: " & LastException)
		
	End Try
End Sub

Sub lvKeys_MouseClicked (EventData As MouseEvent)
	Try
		Dim sel As List = lvKeys.GetSelectedIndices
		If sel.IsInitialized = False Then 
			EditTV.reset
			Return
		End If
		PrimaryKey = PrimaryKey.ToLowerCase
		SecondaryKey = SecondaryKey.tolowercase
		Dim index As Int = sel.Get(0)
		If index = -1 Then Return
		Dim props As Map
		Dim propsJSON As String
		PrimaryValue = ListViewGetItemText(lvKeys,index)
		'kvs.Initialize(File.dirtemp,SavePath)
		If kvs.ContainsKey(PrimaryValue) Then
			props = kvs.GetObject(PrimaryValue)
			EditTV.SetPropertyBag(props)
			EditTV.TV.ScrollTo(0)
			props = EditTV.GetPropertyBag
			propsJSON = Map2Json(props)
			If SubExists(CallBack, EventName & "_ItemSelected") Then
				CallSub3(CallBack, EventName & "_ItemSelected", propsJSON, props)
			End If
		Else
			LogError("ListView Item could not be retrieved")
			EditTV.MsgBoxError(ParentForm,"Item Error","The item could not be retrieved, you might need to reload the list!")
			'load old records
			Dim sout As String = File.ReadString(File.Dirapp,SavePather)
			Load(sout,minSize,maxSize)
		End If
	Catch
		LogError("ListView Item could not be retrieved")
		EditTV.MsgBoxError(ParentForm,"Item Error","The item could not be retrieved, you might need to reload the list!")
	End Try
End Sub

Sub EnableSort
	btnSortRC.Enabled = True
	btnSortRC.Visible = True
End Sub

Sub btnSortRC_Click
	Try
		Dim m As Map = EditTV.getpropertybag
		If m.ContainsKey("row") = False Then Return
		If m.ContainsKey("cell") = False Then Return
		Dim lItems As List = Json2List(ToString)
		Dim rsCnt As Int
		Dim rsTot As Int = lItems.Size - 1
		For rsCnt = 0 To rsTot
			Dim  mItem As Map = lItems.Get(rsCnt)
			Dim row As String = mItem.getdefault("row","")
			Dim cell As String = mItem.getdefault("cell","")
			'get the current id id and key
			Dim sKey As String = $"${row}${cell}"$
			mItem.Put(PrimaryKey.tolowercase,sKey)
			lItems.Set(rsCnt,mItem)
		Next
		Dim nItems As String = List2JSON(lItems)
		Load(nItems,minSize,maxSize)
		If SubExists(CallBack, EventName & "_Sorted") Then
			CallSub2(CallBack, EventName & "_Sorted", ToString)
		End If
	Catch
		LogError("btnSortRC_Action: " & LastException)
	End Try
End Sub